<?php

/**
 * Description of widget_castlist
 *
 * @author Rika.K
 */
class CP5_Widget_CastList extends CP5_Widget {

    function __construct() {
        $this->widget_name = 'キャスト一覧';
        $this->widget_default_label = 'キャスト一覧';

        add_action( 'admin_print_scripts-widgets.php', array( $this, 'admin_scripts' ) );
        add_action( 'customize_controls_enqueue_scripts', array( $this, 'admin_scripts' ) );

        parent::__construct();
    }

    protected function option_param() {
        return array(
            // 'page_limit' => '1画面あたりの表示キャスト数',
          //  'age' => '年齢を表示',
            // 'if_caption' => '見出しテキスト',
            // 'if_height' => '身長',
            //  'if_weight' => '体重',
            '3size' => '身長・スリーサイズを表示',
            'icon' => 'アイコンを表示',
                //  'if_attr' => '属性',
                //  'if_shop' => '店舗名',
        );
    }

    protected function instance_update_default( $instance ) {
        $instance = parent::instance_update_default( $instance );



        return $instance;
    }

    protected function get_wp_query( $args, $instance ) {

        $cast_args = array( 
            'post_type' => 'cast',
            'post_status' => 'publish'
            );
        
        if(isset($instance['page_limit']) && $instance['page_limit']){
          
         $cast_args['posts_per_page'] = $instance['page_limit'];
            
        }        
        
        $this->wpq = new WP_Query($cast_args);
    }

    /**
     * ウィジェット本体
     * @param type $args
     * @param type $instance
     */
    public function widget( $args, $instance ) {
        $instance = $this->instance_update_default( $instance );

        //WP_Query実行
        $this->get_wp_query( $args, $instance );

        echo $args['before_widget'];
        echo $args['before_title'] . $instance['title'] . $args['after_title'];

        /**
         * 現在時刻とスケジュールの取得
         */
        $now = CP5::get_switchTime( 'U' );

        $schObj = new CP5_Schedule();
        $schObj->setRange( 1 );

        //スケジュール検索は、UTCで行う
        //$cp5_startTime = CP5::get_switchTime( 'U', $now, false ) - CP5::get_gmt_offset();
        //$cp5_endTime = $cp5_startTime + DAY_IN_SECONDS;

       // $schData = CP5_Schedule::get_scheduleByTime( $cp5_startTime, $cp5_endTime, '', '', false );
        //$cp5_gidArr = $schData;

        $util = new CP5_util( '_castField_' );
 
        //待ちヒメ取得は現在時刻で行う

        //$machihimeObj = new CP5_Machihime();
       // $machihimeObj->load_all_status( $cp5_gidArr );

        if ( $this->wpq->have_posts() ):
            echo '<ul class="cast-list row columns small-up-1 medium-up-' . $instance['cast_column'] . ' cast-lists-frame items-container no-bullet ' . $instance['layout'] . '">';

            // if(){
            // }else{
            while ( $this->wpq->have_posts() ) : $this->wpq->the_post();
                $util->set_ID( get_the_ID() );

                $layout = $instance['layout'];

                if ( $layout === 'vertical' ) {

                    $image_layout_class = 'small-4 medium-12 columns';
                    $section_layout_class = 'small-8 medium-12 columns text-left medium-text-center';
                } else {

                    $image_layout_class = 'small-4 medium-4 columns';
                    $section_layout_class = 'small-8 medium-8 columns text-left';
                }

                /* スケジュールデータ出力 */
                $castID = get_the_ID();
               // $currentSchs = CP5_Schedule::get_scheduleByCastID( $castID, $cp5_gidArr );
               // $schObj = $currentSchs[0];

                //$thisState = $machihimeObj->get_stateSingle( $castID );

                //$timeFormat = get_option( 'time_format' );
               // $inTime = date( $timeFormat, CP5::add_gmt_offset( cp5_ms2sec( $schObj->in_time ) ) );
                //$outTime = date( $timeFormat, CP5::add_gmt_offset( cp5_ms2sec( $schObj->out_time ) ) );

               // if ( $thisState->statusCode == -1 ) {
                 //   $thisState->statusCode = 10;
               // }

//ラスト表記の確認
//$outTime = cp5_is_outTimeLast( $shop_id, $schObj, $outTime );
//待ちヒメステータス取得
//$thisState = $machihimeObj->get_stateSingle( $castID, $currentSch );
//カスタムフィールド値の取得
//$util->set_ID( $castID );
                ?>
                <li class="columns action">
                    <div class="cast-frame item">
                        <a href="<?php echo get_permalink( $castID ); ?>">
                            <div class="row collapse">
                                <div class="cast-image <?php echo $image_layout_class; ?>">
                                    <?php echo cp5_get_cast_image( $castID, 'cast-s' ); ?>
                                </div>
                                <div class="cast-section <?php echo $section_layout_class; ?>">
                                    <div class="cast-name"><?php echo cp5_get_cast_name( $castID ); ?></div>
                                    <?php if ( $instance['3size'] === 'on' ) { ?>
                                                        <div class="cast-size"><?php echo cp5_get_cast_size( $castID ); ?></div>
                                    <?php } ?>
                                    <?php if ( $instance['icon'] === 'on' ) { ?>
                                          <div class="cast-icon"><?php echo cp5_get_cast_icons( $castID ); ?></div>
                                    <?php } ?>
                                </div>
                            </div>
                        </a>
                    </div>
                </li>
                <?php
            endwhile;
            // 投稿データをリセット
            wp_reset_postdata();
            // }

            echo '</ul>';
        else:
            echo '<div class="text-center no-data">' . __( 'No results found.', 'castpro5' ) . '</div>';
        endif;

        echo $args['after_widget'];
    }

    public function loop_cast( $wpq, $instance, $option = null, $callback = null ) {
        
    }

    /**
     * ウィジェットオプションフォーム
     * @param type $instance
     */
    public function form( $instance ) {
      
           $instance = wp_parse_args( ( array ) $instance, array(
            'title' => '',
            'cast_column' => 4,
            'layout' => 'vertical',
            'page_limit' => 10,
            '3size' => '',
            'icon' => '',
                )
        );   //クエリーとデフォルト値のマージ（合併）

        //オプション項目
        $options = $this->option_param();
        ?>        
        <p>
            <label for="<?php echo $this->get_field_id( 'title' ); ?>"><?php _e( 'Title:', 'castpro5' ); ?></label> 
            <input class="widefat" id="<?php echo $this->get_field_id( 'title' ); ?>" name="<?php echo $this->get_field_name( 'title' ); ?>" type="text" value="<?php echo esc_attr( $instance['title'] ); ?>" />
        </p>
        <p>
            <label for="<?php echo $this->get_field_id( 'page-limit' ); ?>"><?php _e( 'Display number of people', 'castpro5' ); ?></label> 
            <input class="tiny-text" id="<?php echo $this->get_field_id( 'page_limit' ); ?>" name="<?php echo $this->get_field_name( 'page_limit' ); ?>" type="number" value="<?php echo esc_attr( $instance['page_limit'] ); ?>" step="1" min="1" size="3" />
        </p>

        <p>
            <label for="<?php echo $this->get_field_id( 'cast-column' ); ?>"><?php _e( 'Number of columns:', 'castpro5' ); ?></label> 

            <input id="<?php echo $this->get_field_id( 'cast-column' ); ?>" name="<?php echo $this->get_field_name( 'cast_column' ); ?>" type="range" class="column-slider" value="<?php echo esc_attr( $instance['cast_column'] ); ?>" step="1" min="1" max="10" /><span class="column-slider-val"><?php echo esc_attr( $instance['cast_column'] ); ?></span>
        </p>
        <p><?php _e( 'Layout', 'castpro5' ); ?></p>
        <p>
        <ul class="cast-layout-type">
            <li>
                <label for="<?php echo $this->get_field_id( 'layout-vertical' ); ?>">
                    <img src="<?php echo plugins_url( 'images/vertical.png',CP5PE_MAIN); ?>" alt="vertical"><br>
                    <input id="<?php echo $this->get_field_id( 'layout-vertical' ); ?>" name="<?php echo $this->get_field_name( 'layout' ); ?>" type="radio" value="vertical" <?php checked( $instance['layout'], 'vertical' ); ?> /><br>
                    <?php _e( 'Vertical', 'castpro5' ); ?>
                </label>
            </li>
            <li>
                <label for="<?php echo $this->get_field_id( 'layout-horizontal' ); ?>">
                    <img src="<?php echo plugins_url( 'images/horizontal.png', CP5PE_MAIN); ?>" alt="horizontal"><br>
                    <input id="<?php echo $this->get_field_id( 'layout-horizontal' ); ?>" name="<?php echo $this->get_field_name( 'layout' ); ?>" type="radio" value="horizontal" <?php checked( $instance['layout'], 'horizontal' ); ?> /><br>
                    <?php _e( 'Horizontal', 'castpro5' ); ?>
                </label>
            </li>
        </ul>
        </p>


        <p>
            <?php
            foreach ( $options as $key => $value ):
                ?>
                <input class="widefat" id="<?php echo $this->get_field_id( $key ); ?>" name="<?php echo $this->get_field_name( $key ); ?>" type="checkbox" <?php checked( 'on', $instance[$key] ); ?>/><label for="<?php echo $this->get_field_id( $key ); ?>"><?php echo $value ?></label><br>
            <?php endforeach; ?>
        </p>
        <?php
    }

    function update( $new_instance, $old_instance ) {
        // ウィジェットの設定の更新処理を記述。主にセキュリティを考えたサニタイズ用
       
       $new_instance['title'] = strip_tags( $new_instance['title'] );    //不要なNULL、HTMLタグ、PHPソースコードを排除

        return  $new_instance;
    }

    function admin_scripts() {
       
        wp_enqueue_script( 'widget-range', plugins_url( 'js/widget-range.js',CP5PE_MAIN ), array( 'jquery' ) );
    }

}

/*
 * Wordpressへ登録 
 */

add_action( 'widgets_init', function() {
    return register_widget( 'CP5_Widget_CastList' );
} );
