<?php

    /**
     * Description of widget_castlist
     *
     * @author Rika.K
     */
    class CP5_Widget_CastSlider extends CP5_Widget {

        function __construct() {
            $this->widget_name = 'キャストスライダー';
            $this->widget_default_label = 'キャストスライダー';

            add_action( 'wp_enqueue_scripts', array( $this, 'widget_castslider_enqueue_scripts' ), 10 );

            parent::__construct();
        }

        protected function option_param() {
            return array(
                '3size' => '身長・スリーサイズを表示',
                'icon' => 'アイコンを表示',
            );
        }

        protected function get_wp_query( $args, $instance ) {

            $cast_args = array(
                'post_type' => 'cast',
                'post_status' => 'publish',
                'no_found_rows' => true,
            );

            if ( isset( $instance['page_limit'] ) && $instance['page_limit'] ) {

                $cast_args['posts_per_page'] = $instance['page_limit'];
            }

            //絞り込み条件
            if ( !empty( $instance['cast_cat_id'] ) ) {

                $cast_args['tax_query'][] = array(
                    'taxonomy' => 'cast_attr',
                    'field' => 'term_id',
                    'terms' => $instance['cast_cat_id'],
                    'operator' => 'AND'
                );
            }

            $this->wpq = new WP_Query( $cast_args );
        }

        /**
         * ウィジェット本体
         * @param type $args
         * @param type $instance
         */
        public function widget( $args, $instance ) {

            //WP_Query実行
            $this->get_wp_query( $args, $instance );

            echo $args['before_widget'];
            echo $args['before_title'] . $instance['title'] . $args['after_title'];

            /**
             * 現在時刻とスケジュールの取得
             */
            //    $now = CP5::get_switchTime( 'U' );
            //      $schObj = new CP5_Schedule();
            //   $schObj->setRange( 1 );
            //スケジュール検索は、UTCで行う
            //    $cp5_startTime = CP5::get_switchTime( 'U', $now, false ) - CP5::get_gmt_offset();
            //     $cp5_endTime = $cp5_startTime + DAY_IN_SECONDS;
            //      $schData = CP5_Schedule::get_scheduleByTime( $cp5_startTime, $cp5_endTime, '', '', false );
            //  $cp5_gidArr = $schData;
            // $util = new CP5_util( '_castField_' );
            //   $key = cp5_get_cast_id_column_short();
            //待ちヒメ取得は現在時刻で行う
            // if ( class_exists( 'CP5_Machihime' ) ) {
            //  $machihimeObj = new CP5_Machihime();
            //  $machihimeObj->load_all_status( $cp5_gidArr );
            //  }

            if ( $this->wpq->have_posts() ):
                echo '<div id="carousel-container-' . $this->id . '" class="owl-carousel owl-theme">';

                // if(){
                // }else{
                while ( $this->wpq->have_posts() ) : $this->wpq->the_post();
                    //   $util->set_ID( get_the_ID() );

                    /* スケジュールデータ出力 */
                    $castID = get_the_ID();
                    // $currentSchs = CP5_Schedule::get_scheduleByCastID( $castID, $cp5_gidArr );
                    // $schObj = $currentSchs[0];
                    // if ( class_exists( 'CP5_Machihime' ) ) {
                    //     $thisState = $machihimeObj->get_stateSingle( $castID );
                    //  }
                    //  $timeFormat = get_option( 'time_format' );
                    //  $inTime = date( $timeFormat, CP5::add_gmt_offset( cp5_ms2sec( $schObj->in_time ) ) );
                    //  $outTime = date( $timeFormat, CP5::add_gmt_offset( cp5_ms2sec( $schObj->out_time ) ) );
                    // if ( $thisState->statusCode == -1 ) {
                    //   $thisState->statusCode = 10;
                    // }
                    ?>
                    <div class="item text-center">
                        <a href="<?php echo get_permalink(); ?>">               
                            <div class="cast-frame">
                                <div class="cast-image">
                                    <?php echo cp5_get_cast_image( $castID, 'cast-s' ); ?>
                                </div>
                                <div class="cast-section text">
                                    <div class="cast-name"><?php echo cp5_get_cast_name( $castID ); ?></div>                                
                                    <?php if ( isset( $instance['3size'] ) && $instance['3size'] === 'on' ) { ?>
                                        <div class="cast-size"><?php echo cp5_get_cast_size( $castID ); ?></div>
                                    <?php } ?>
                                    <?php if ( isset( $instance['icon'] ) && $instance['icon'] === 'on' ) { ?>
                                        <div class="cast-icon"><?php echo cp5_get_cast_icons( $castID ); ?></div>
                                    <?php } ?>
                                </div>
                            </div>
                        </a>                           
                    </div>
                    <?php
                endwhile;
                // 投稿データをリセット
                wp_reset_postdata();
                ?>
                <?php echo '</div>'; ?>

                <?php
            else:
                echo '<div class="text-center no-data">' . __( 'No results found.', 'castpro5' ) . '</div>';
            endif;

            echo $args['after_widget'];
        }

        /**
         * ウィジェットオプションフォーム
         * @param type $instance
         */
        public function form( $instance ) {

            $instance = wp_parse_args( ( array ) $instance, array(
                'title' => '',
                'slidespeed' => 500,
                'slidenumber' => 1,
                'slidenumber_mobile' => 1,
                'effect' => '',
                'autoheight' => '',
                'loop' => '',
                'pagination' => '',
                'navigation' => '',
                'page_limit' => 10,
                'cast_cat_id' => '',
                '3size' => '',
                'icon' => '',
                    )
            );   //クエリーとデフォルト値のマージ（合併）
            //   
            //オプション項目
            $options = $this->option_param();
            ?>
            <p>
                <label for="<?php echo $this->get_field_id( 'title' ); ?>"><?php _e( 'Title:', 'castpro5' ); ?></label> 
                <input class="widefat" id="<?php echo $this->get_field_id( 'title' ); ?>" name="<?php echo $this->get_field_name( 'title' ); ?>" type="text" value="<?php echo esc_attr( $instance['title'] ); ?>" />
            </p>

            <p>
                <label for="<?php echo $this->get_field_id( 'slidespeed' ); ?>"><?php _e( 'Slide of speed:', 'castpro5' ); ?></label>
                <input class="widefat" id="<?php echo $this->get_field_id( 'slidespeed' ); ?>" name="<?php echo $this->get_field_name( 'slidespeed' ); ?>" type="number" value="<?php echo esc_attr( $instance['slidespeed'] ); ?>"  step="1" min="0"  />
            </p>

            <p>
                <label for="<?php echo $this->get_field_id( 'slidenumber' ); ?>"><?php _e( 'Number of slides:', 'castpro5' ); ?></label><br>
                <input id="<?php echo $this->get_field_id( 'slidenumber' ); ?>" name="<?php echo $this->get_field_name( 'slidenumber' ); ?>" type="range" class="column-slider" value="<?php echo esc_attr( $instance['slidenumber'] ); ?>" step="1" min="1" max="10" /><span class="column-slider-val"><?php echo esc_attr( $instance['slidenumber'] ); ?></span>
            </p>

            <p>
                <label for="<?php echo $this->get_field_id( 'slidenumber-mobile' ); ?>"><?php _e( 'Number of slides (mobile):', 'castpro5' ); ?></label><br>
                <input id="<?php echo $this->get_field_id( 'slidenumber-mobile' ); ?>" name="<?php echo $this->get_field_name( 'slidenumber_mobile' ); ?>" type="range" class="column-slider" value="<?php echo esc_attr( $instance['slidenumber_mobile'] ); ?>" step="1" min="1" max="10" /><span class="column-slider-val"><?php echo esc_attr( $instance['slidenumber_mobile'] ); ?></span>
            </p>

            <p>
                <label for="<?php echo $this->get_field_id( 'effect' ); ?>"><?php _e( 'Slider Effect:', 'castpro5' ); ?></label><br>         
                <select name="<?php echo $this->get_field_name( 'effect' ); ?>" id="<?php echo $this->get_field_id( 'effect' ); ?>">         
                    <option value="slide" <?php selected( 'slide', $instance['effect'] ); ?>><?php _e( 'Slide', 'castpro5' ); ?></option>     
                    <option value="fade" <?php selected( 'fade', $instance['effect'] ); ?>><?php _e( 'Fade', 'castpro5' ); ?></option>     
                    <?php /*   <option value="cube" <?php selected( 'cube', $instance['effect'] ); ?>><?php _e( 'Cube', 'castpro5' ); ?></option>     
                      <option value="coverflow" <?php selected( 'coverflow', $instance['effect'] ); ?>><?php _e( 'Coverflow', 'castpro5' ); ?></option>
                      <option value="flip" <?php selected( 'flip', $instance['effect'] ); ?>><?php _e( 'Flip', 'castpro5' ); ?></option> */ ?>
                </select><br>
                <span class="description customize-control-description">※「フェード」は1枚表示の場合のみ有効</span><br>
            </p>

            <p>
                <input class="checkbox" id="<?php echo $this->get_field_id( 'autoheight' ); ?>" name="<?php echo $this->get_field_name( 'autoheight' ); ?>" type="checkbox" <?php checked( 'on', $instance['autoheight'] ); ?>> <label for="<?php echo $this->get_field_id( 'autoheight' ); ?>"><?php _e( 'To enable the automatic adjustment of height', 'castpro5' ); ?></label><br>

                <input class="checkbox" id="<?php echo $this->get_field_id( 'loop' ); ?>" name="<?php echo $this->get_field_name( 'loop' ); ?>" type="checkbox" <?php checked( 'on', $instance['loop'] ); ?>> <label for="<?php echo $this->get_field_id( 'loop' ); ?>"><?php _e( 'Enable the loop', 'castpro5' ); ?></label><br>

                <input class="checkbox" id="<?php echo $this->get_field_id( 'pagination' ); ?>" name="<?php echo $this->get_field_name( 'pagination' ); ?>" type="checkbox" <?php checked( 'on', $instance['pagination'] ); ?>> <label for="<?php echo $this->get_field_id( 'pagination' ); ?>"><?php _e( 'Displays the pagination', 'castpro5' ); ?></label><br>

                <input class="checkbox" id="<?php echo $this->get_field_id( 'navigation' ); ?>" name="<?php echo $this->get_field_name( 'navigation' ); ?>" type="checkbox" <?php checked( 'on', $instance['navigation'] ); ?>> <label for="<?php echo $this->get_field_id( 'navigation' ); ?>"><?php _e( 'Display the navigation', 'castpro5' ); ?></label><br>
            </p>

            <p>
                <label for="<?php echo $this->get_field_id( 'page-limit' ); ?>"><?php _e( 'Display number of people', 'castpro5' ); ?></label>
                <input class="tiny-text" id="<?php echo $this->get_field_id( 'page_limit' ); ?>" name="<?php echo $this->get_field_name( 'page_limit' ); ?>" type="number" value="<?php echo esc_attr( $instance['page_limit'] ); ?>" step="1" min="1" size="3" />
            </p>

            <p>
                <label for="<?php echo $this->get_field_id( 'cast_cat_id' ); ?>"><?php _e( 'Category:', 'castpro5' ); ?></label>
                <?php $cast_cat_terms = get_terms( 'cast_attr', array( 'hide_empty' => false ) ); ?>
                <select name="<?php echo $this->get_field_name( 'cast_cat_id' ); ?>" id="<?php echo $this->get_field_id( 'cast_cat_id' ); ?>">
                    <option value="" <?php selected( '', $instance['cast_cat_id'] ); ?>><?php _e( '設定しない', 'castpro5' ); ?></option>
                    <?php foreach ( $cast_cat_terms as $cast_cat_term ) { ?>
                        <option value="<?php echo esc_attr( $cast_cat_term->term_id ); ?>" <?php selected( $cast_cat_term->term_id, $instance['cast_cat_id'] ); ?>><?php echo esc_attr( $cast_cat_term->name ); ?></option>
                    <?php } ?>
                </select>
            </p>
            <p>
                <?php foreach ( $options as $key => $value ): ?>
                    <input class="widefat" id="<?php echo $this->get_field_id( $key ); ?>" name="<?php echo $this->get_field_name( $key ); ?>" type="checkbox" <?php checked( 'on', $instance[$key] ); ?>/><label for="<?php echo $this->get_field_id( $key ); ?>"><?php echo $value ?></label><br>
                <?php endforeach; ?>
            </p>
            <?php
        }

        function update( $new_instance, $old_instance ) {
            // ウィジェットの設定の更新処理を記述。主にセキュリティを考えたサニタイズ用

            $new_instance['title'] = strip_tags( $new_instance['title'] );    //不要なNULL、HTMLタグ、PHPソースコードを排除

            return $new_instance;
        }

        function widget_castslider_enqueue_scripts( $instance ) {

            wp_enqueue_style( 'owlcarousel', get_template_directory_uri() . '/lib/owlcarousel/assets/owl.carousel.min.css', array(), '2.2.0', 'all' );
            wp_enqueue_style( 'owlc-theme-default', get_template_directory_uri() . '/lib/owlcarousel/assets/owl.theme.default.min.css', array( 'owlcarousel' ), '2.2.0', 'all' );
            wp_enqueue_script( 'owlcarousel', get_template_directory_uri() . '/lib/owlcarousel/owl.carousel.min.js', array( 'jquery' ), '2.2.0', true );

            $slider_options = get_option( $this->option_name );

            foreach ( ( array ) $slider_options as $slider_key => $slider_op ) {

                if ( !is_active_widget( false, $this->id_base . '-' . $slider_key, $this->id_base, true ) ) {
                    continue;
                }
                
                
                if ( isset( $slider_op['page_limit'] ) && $slider_op['page_limit'] ) {

                    $instance['page_limit'] = $slider_op['page_limit'];
                }

                if ( isset( $slider_op['cast_cat_id'] ) && $slider_op['cast_cat_id'] ) {

                    $instance['cast_cat_id'] = $slider_op['cast_cat_id'];
                }

                //WP_Query実行
                $this->get_wp_query( '', $instance );

                $slider_config = array();

                //スピード
                if ( isset( $slider_op['slidespeed'] ) && $slider_op['slidespeed'] ) {
                    $slider_config['smartSpeed'] = ( int ) $slider_op['slidespeed'];
                }

                //ループ

                if ( isset( $slider_op['loop'] ) && ($this->wpq->post_count > ( int ) $slider_op['slidenumber'] ) ) {
                    $slider_config['responsive']['768']['loop'] = true;
                }

                if ( isset( $slider_op['loop'] ) && ($this->wpq->post_count > ( int ) $slider_op['slidenumber_mobile'] ) ) {
                    $slider_config['responsive']['0']['loop'] = true;
                }

                //エフェクト
                if ( isset( $slider_op['effect'] ) && $slider_op['effect'] === 'fade' ) {
                    $slider_config['animateOut'] = 'fadeOut';
                }


                //スライド数        
                if ( isset( $slider_op['slidenumber'] ) && $slider_op['slidenumber'] ) {
                    $slider_config['items'] = ( int ) $slider_op['slidenumber'];
                }

                //スライドスマートフォン       
                if ( isset( $slider_op['slidenumber_mobile'] ) && $slider_op['slidenumber_mobile'] ) {
                    $slider_config['responsive']['768']['items'] = ( int ) $slider_op['slidenumber'];
                    $slider_config['responsive']['0']['items'] = ( int ) $slider_op['slidenumber_mobile'];
                }

                //高さを自動調整
                if ( isset( $slider_op['autoheight'] ) && $slider_op['autoheight'] === 'on' ) {
                    $slider_config['autoHeight'] = true;
                }

                //ページネーション
                if ( isset( $slider_op['pagination'] ) && $slider_op['pagination'] === 'on' ) {
                    $slider_config['dots'] = true;
                } else {

                    $slider_config['dots'] = false;
                }

                //ナビゲーション
                if ( isset( $slider_op['navigation'] ) && $slider_op['navigation'] == 'on' ) {
                    $slider_config['nav'] = true;
                    $slider_config['navClass'] = array( 'slide-prev', 'slide-next' );
                    $slider_config['navText'] = array( '', '' );
                }

                wp_reset_postdata();

                wp_add_inline_script( 'owlcarousel', "$(function() {
             var owl" . $this->id_base . $slider_key . " = $('#carousel-container-" . $this->id_base . "-" . $slider_key . "');                 
             owl" . $this->id_base . $slider_key . ".owlCarousel(" . json_encode( $slider_config ) . ");
        });" );
            }
        }

    }

// }

    /*
     * Wordpressへ登録 
     */

    add_action( 'widgets_init', function() {
        return register_widget( 'CP5_Widget_CastSlider' );
    } );
    