<?php

/**
 * Description of widget_castlist
 *
 * @author Rika.K
 */
class CP5_Widget_Schedule extends CP5_Widget_CastList {

    protected $startTime;
    protected $endTime;
    protected $gidArr = array();

    function __construct() {
        $this->widget_name = '本日の出勤一覧';
        $this->widget_default_label = '本日の出勤一覧';

        CP5_Widget::__construct();
    }
    
    /**
     * スケジュール一覧
     * @param type $args
     * @param type $instance
     */
    public function widget( $args, $instance ) {
        $instance = $this->instance_update_default( $instance );

        //現在時刻
        $ts = time();

        $this->startTime = CP5::get_switchTime( 'U' ) - CP5::get_gmt_offset();
        $this->endTime = $this->startTime + DAY_IN_SECONDS;

        $dateFormat = get_option( 'date_format' );
        //$titleDt = date_i18n( $dateFormat, CP5::add_gmt_offset( $this->startTime ) );
        //$instance['title'].=$titleDt;

        echo $args['before_widget'];

        echo $args['before_title'] . $instance['title'] . $args['after_title'];

        //WP_Query実行
        $this->get_wp_query( $args, $instance );        
          
        $machihimeObj = new CP5_Machihime();
        $machihimeObj->load_all_status( $this->gidArr );
        ?>
        <div class="query-count text-right"><?php echo sprintf( __( 'Attendance of %s, %d people', 'castpro5' ), date_i18n( $dateFormat, CP5::add_gmt_offset( $ts ) ), $this->wpq->found_posts ); ?></div>
        <?php
        if ( $this->wpq->have_posts() ):
           echo '<ul class="cast-list row columns small-up-1 medium-up-' . $instance['cast_column'] . ' cast-lists-frame items-container no-bullet '.$instance['layout'].'">';
            while ( $this->wpq->have_posts() ):
                $this->wpq->the_post();
                $castID = get_the_ID();

               $layout = $instance['layout']; 
                
                if($layout === 'vertical'){                   
                        
                    $image_layout_class = 'small-4 medium-12 columns';
                    $section_layout_class = 'small-8 medium-12 columns text-left medium-text-center';
                    
                }else{
                 
                    $image_layout_class = 'small-4 medium-4 columns';
                    $section_layout_class = 'small-8 medium-8 columns text-left';
                     
                }
                 if ( class_exists( 'CP5_Machihime' ) ) {
                     
                        $thisState = $machihimeObj->get_stateSingle( $castID );
                 }
             
                $schObj = $thisState->sch[0];
                $timeFormat = get_option( 'time_format' );
                $inTime = date( $timeFormat, CP5::add_gmt_offset( cp5_ms2sec( $schObj->in_time ) ) );

                $outTime = date( $timeFormat, CP5::add_gmt_offset( cp5_ms2sec( $schObj->out_time ) ) );

                //店舗IDを取得
                $shop_id = (is_main_site()) ? get_post_meta( get_the_ID(), CP5::SyncShopID, true ) : get_current_blog_id();
                //ラスト表記の確認
                $outTime = cp5_is_outTimeLast( $shop_id, $schObj, $outTime );

                /**
                 * スケジュールデータ出力ここまで
                 */
                ?>
                <li class="columns" data-girlid="<?php echo $castID; ?>">
                    <div class="cast-frame item lazyload" data-mh="cast-list">
                        <a href="<?php echo get_permalink(); ?>">
                            <div class="row collapse">
                              <div class="cast-image <?php echo $image_layout_class; ?>">
                                  <?php echo cp5_get_cast_image( $castID, 'cast-s' ); ?>
                                </div>
                               <div class="cast-section <?php echo $section_layout_class; ?>">
                                    <div class="cast-name"><?php echo cp5_get_cast_name( $castID ); ?></div>
                                    
                                    <?php if (  isset($instance['3size']) &&  $instance['3size'] === 'on' ) { ?>
                                           <div class="cast-size"><?php echo cp5_get_cast_size( $castID ); ?></div>
                                    <?php } ?>
                                   
                                    <div class="cast-schedule-time">
                                        <?php echo sprintf( '<i class="fa fa-clock-o"></i> <span class="num">%s</span> - <span class="num">%s</span>', $inTime, $outTime ); ?>
                                    </div>

                                    <?php if ( isset($instance['icon']) && $instance['icon'] === 'on' ) { ?>
                                          <div class="cast-icon"><?php echo cp5_get_cast_icons( $castID ); ?></div>
                                    <?php } ?>
                                          
                                    <?php if ( $schObj->free_text ) { ?>
                                        <div class="cast-schedule-comment free-text">
                                        <?php echo sprintf( '<p>%s</p>', $schObj->free_text ); ?>
                                        </div>
                                        <?php } ?>
                                     <?php if ( class_exists( 'CP5_Machihime' ) ) { ?>
                                    <div class="cast-state-icon text-center">                      
                                    <?php $machihimeObj->echo_stateIcon( $thisState, 'div' ); ?>
                                    </div>
                                    <div class="cast-state-messege text-center">
                                        <?php $machihimeObj->echo_stateMessage( $thisState, true );  ?>
                                    </div>
                                    <div class="marquee"><p><?php echo $thisState->comment; ?></p></div>
                                    <?php } ?>
                                </div>
                            </div>
                        </a>
                    </div>
                </li>
                <?php
            endwhile;
            echo '</ul>';
        else:
            echo '<div class="text-center no-data">' . __( 'No results found.', 'castpro5' ) . '</div>';
        endif;
        // 投稿データをリセット
        wp_reset_postdata();

        echo $args['after_widget'];
    }

    /**
     * WP_Queryの生成
     * @param type $args
     * @param type $instance
     */
    protected function get_wp_query( $args, $instance ) {
        
        
        
        //先にスケジュールデータを確保しておく
        $schData = CP5_Schedule::get_scheduleByTime( $this->startTime, $this->endTime, '', '', false );

        if ( empty( $schData ) ) {
            $schData = array();
        }
        
        if(isset($instance['page_limit']) && $instance['page_limit']){
            $schedule_attr['posts_per_page'] = $instance['page_limit'];
        }
        
                                            $schedule_attr['orderby'] = 'sch_order';
                                    $schedule_attr['order'] = 'ASC';

        $this->wpq = CP5_Schedule::CP5_get_cast_schedule_WP_Query( $this->startTime, $this->endTime,$schedule_attr);
   
        
        $this->gidArr = $schData;
    }

}

/*
 * Wordpressへ登録 
 */

add_action( 'widgets_init', function() {
    return register_widget( 'CP5_Widget_Schedule' );
} );
