<?php

    class CP5_Slider_Widget extends WP_Widget {

        //コンストラクタ：オブジェクト生成時呼び出し
        public function __construct() {
            //admin_print_scripts-管理画面のページ名

            add_action( 'admin_print_scripts-widgets.php', array( $this, 'admin_scripts' ) );
            add_action( 'customize_controls_enqueue_scripts', array( $this, 'admin_scripts' ) );

            add_action( 'wp_enqueue_scripts', array( $this, 'widget_slider_enqueue_scripts' ), 10 );

            //名前
            $name = __( 'image slider', 'castpro5' );
            //説明文
            $widget_ops = array( 'description' => __( 'image slider', 'castpro5' ) );
            //管理画面でのサイズ
            $control_ops = array();

            parent::__construct( false, $name, $widget_ops, $control_ops );
        }

        //ウィジェット：画面表示
        public function widget( $args, $instance ) {

            extract( $args );

            echo $args['before_widget'];

            if ( $instance['title'] ) {
                echo $args['before_title'] . $instance['title'] . $args['after_title'];
            }

            $sliderimage = $instance['sliders'];

            foreach ( ( array ) $sliderimage as $key => $value ) {

                if ( $value['slider_order'] ) {
                    $sort[$key] = $value['slider_order'];
                } else {
                    $sort[$key] = $key;
                }
            }

            if ( $sliderimage ) {
                array_multisort( $sort, SORT_ASC, $sliderimage );
            }
            ?>
            <div <?php echo 'id="swiper-container-' . $this->id . '"'; ?> class="swiper-container">
                <div class="swiper-wrapper">
            <?php foreach ( ( array ) $sliderimage as $key => $sliderimage ) { ?>
                        <div class="swiper-slide text-center">
                        <?php
                        if ( $sliderimage['slider_blank'] === 'on' ) {

                            $target_blank = 'target="_blank" ';
                        } else {

                            $target_blank = '';
                        }
                        ?>
                            <?php if ( $sliderimage['slider_url'] ) { ?>
                                <a href="<?php echo $sliderimage['slider_url']; ?>" <?php echo $target_blank; ?>>
                            <?php } ?>
                                <img src="<?php echo $sliderimage['slider_image']; ?>" alt="<?php echo $sliderimage['slider_title']; ?>" class="slider-image">
                                <?php if ( $sliderimage['slider_url'] ) { ?>
                                </a>
                                <?php } ?>
                        </div>
                        <?php } ?>
                </div>
                    <?php if ( $instance['pagination'] === 'on' ) { ?>
                    <!-- Add Pagination -->
                    <div class="swiper-pagination swiper-pagination-black"></div>
            <?php } ?>
                <?php if ( $instance['navigation'] === 'on' ) { ?>
                    <!-- Add Arrows -->
                    <div class="swiper-button-next swiper-button-black"></div>
                    <div class="swiper-button-prev swiper-button-black"></div>
            <?php } ?>
            </div>
                <?php
                echo $args['after_widget'];
            }

            //更新時の処理
            public function update( $new_instance, $old_instance ) {

                $new_instance['title'] = strip_tags( $new_instance['title'] );    //不要なNULL、HTMLタグ、PHPソースコードを排除


                return $new_instance;
            }

            //管理画面：ウィジェット画面
            function form( $instance ) {

                $instance = wp_parse_args( ( array ) $instance, array(
                    'title' => '',
                    'sliders' => array(
                        array(
                            'slider_title' => '',
                            'slider_image' => '',
                            'slider_url' => '',
                            'slider_blank' => '',
                            'slider_order' => ''
                        )
                    ),
                    'slidespeed' => 2000,
                    'slidenumber' => 1,
                    'slidenumber_mobile' => 1,
                    'effect' => 'slide',
                    'autoplay' => '',
                    'autoplayspeed' => 5000,
                    'autoheight' => '',
                    'loop' => '',
                    'pagination' => '',
                    'navigation' => '',
                        )
                );   //クエリーとデフォルト値のマージ（合併）


                $sliderimage = $instance['sliders'];
                ?>
            <p>
                <label for="<?php echo $this->get_field_id( 'title' ); ?>"><?php _e( 'Title:', 'castpro5' ); ?></label>
                <input class="widefat" id="<?php echo $this->get_field_id( 'title' ); ?>" name="<?php echo $this->get_field_name( 'title' ); ?>" type="text" value="<?php echo esc_attr( $instance['title'] ); ?>" />
            </p>
            <?php /*
              <p>
              <label for="<?php echo $this->get_field_id( 'width' ); ?>"><?php _e( 'Slider width:', 'castpro5' ); ?></label>
              <input class="widefat" id="<?php echo $this->get_field_id( 'width' ); ?>" name="<?php echo $this->get_field_name( 'width' ); ?>" type="text" value="<?php echo esc_attr( $instance['width'] ); ?>" />
              </p>

              <p>
              <label for="<?php echo $this->get_field_id( 'height' ); ?>"><?php _e( 'Slider height:', 'castpro5' ); ?></label>
              <input class="widefat" id="<?php echo $this->get_field_id( 'height' ); ?>" name="<?php echo $this->get_field_name( 'height' ); ?>" type="text" value="<?php echo esc_attr( $instance['height'] ); ?>" />
              </p>
             */ ?>

            <p>
                <label for="<?php echo $this->get_field_id( 'slidespeed' ); ?>"><?php _e( 'Slide of speed:', 'castpro5' ); ?></label>
                <input class="widefat" id="<?php echo $this->get_field_id( 'slidespeed' ); ?>" name="<?php echo $this->get_field_name( 'slidespeed' ); ?>" type="number" value="<?php echo esc_attr( $instance['slidespeed'] ); ?>" />
            </p>

            <p>
                <label for="<?php echo $this->get_field_id( 'slidenumber' ); ?>"><?php _e( 'Number of slides:', 'castpro5' ); ?></label>
                <input class="widefat" id="<?php echo $this->get_field_id( 'slidenumber' ); ?>" name="<?php echo $this->get_field_name( 'slidenumber' ); ?>" type="number" value="<?php echo esc_attr( $instance['slidenumber'] ); ?>" step="1" min="1" size="5"  />
            </p>

            <p>
                <label for="<?php echo $this->get_field_id( 'effect' ); ?>"><?php _e( 'Slider Effect:', 'castpro5' ); ?></label><br>
                <select name="<?php echo $this->get_field_name( 'effect' ); ?>" id="<?php echo $this->get_field_id( 'effect' ); ?>">
                    <option value="slide" <?php selected( 'slide', $instance['effect'] ); ?>><?php _e( 'Slide', 'castpro5' ); ?></option>
                    <option value="fade" <?php selected( 'fade', $instance['effect'] ); ?>><?php _e( 'Fade', 'castpro5' ); ?></option>
                    <option value="cube" <?php selected( 'cube', $instance['effect'] ); ?>><?php _e( 'Cube', 'castpro5' ); ?></option>
                    <option value="coverflow" <?php selected( 'coverflow', $instance['effect'] ); ?>><?php _e( 'Coverflow', 'castpro5' ); ?></option>
                    <option value="flip" <?php selected( 'flip', $instance['effect'] ); ?>><?php _e( 'Flip', 'castpro5' ); ?></option>
                </select>
            </p>

            <p>
                <input class="checkbox" id="<?php echo $this->get_field_id( 'autoplay' ); ?>" name="<?php echo $this->get_field_name( 'autoplay' ); ?>" type="checkbox" <?php checked( 'on', $instance['autoplay'] ); ?>> <label for="<?php echo $this->get_field_id( 'autoplay' ); ?>"><?php _e( 'Enable Auto Play', 'castpro5' ); ?></label><br>
                <label for="<?php echo $this->get_field_id( 'autoplayspeed' ); ?>"><?php _e( 'Auto Play speed:', 'castpro5' ); ?></label>
                <input class="widefat" id="<?php echo $this->get_field_id( 'slidespeed' ); ?>" name="<?php echo $this->get_field_name( 'autoplayspeed' ); ?>" type="number" value="<?php echo esc_attr( $instance['autoplayspeed'] ); ?>" />
            </p>

            <p>
                <input class="checkbox" id="<?php echo $this->get_field_id( 'autoheight' ); ?>" name="<?php echo $this->get_field_name( 'autoheight' ); ?>" type="checkbox" <?php checked( 'on', $instance['autoheight'] ); ?>> <label for="<?php echo $this->get_field_id( 'autoheight' ); ?>"><?php _e( 'To enable the automatic adjustment of height', 'castpro5' ); ?></label><br>

                <input class="checkbox" id="<?php echo $this->get_field_id( 'loop' ); ?>" name="<?php echo $this->get_field_name( 'loop' ); ?>" type="checkbox" <?php checked( 'on', $instance['loop'] ); ?>> <label for="<?php echo $this->get_field_id( 'loop' ); ?>"><?php _e( 'Enable the loop', 'castpro5' ); ?></label><br>

                <input class="checkbox" id="<?php echo $this->get_field_id( 'pagination' ); ?>" name="<?php echo $this->get_field_name( 'pagination' ); ?>" type="checkbox" <?php checked( 'on', $instance['pagination'] ); ?>> <label for="<?php echo $this->get_field_id( 'pagination' ); ?>"><?php _e( 'Displays the pagination', 'castpro5' ); ?></label><br>


                <input class="checkbox" id="<?php echo $this->get_field_id( 'navigation' ); ?>" name="<?php echo $this->get_field_name( 'navigation' ); ?>" type="checkbox" <?php checked( 'on', $instance['navigation'] ); ?>> <label for="<?php echo $this->get_field_id( 'navigation' ); ?>"><?php _e( 'Display the navigation', 'castpro5' ); ?></label><br>
            </p>

            <ul class="group-items cp5-slider-images">
            <?php
            foreach ( ( array ) $sliderimage as $key => $sliderimage ) {

                $slider_title = ($sliderimage['slider_title']) ? $sliderimage['slider_title'] : sprintf( __( 'slider %d', 'castpro5' ), $key + 1 );
                $slider_order = ($sliderimage['slider_order']) ? $sliderimage['slider_order'] : $key + 1;
                ?>
                    <li id="<?php echo $this->get_field_id( 'sliders[' . $key . ']' ); ?>" class="group-item" data-id="<?php echo $this->get_field_id( 'sliders[' . $key . ']' ); ?>" data-name="<?php echo $this->get_field_name( 'sliders[' . $key . ']' ); ?>" data-base="widget-<?php echo $this->id_base; ?>" data-number="<?php echo $this->number; ?>">
                        <div class="repeater-row-header ui-sortable-handle">
                            <span class="repeater-row-label handle"><?php echo esc_attr( $slider_title ); ?></span>
                            <a class="hide-if-no-js" href="#">
                                <i class="dashicons dashicons-arrow-down repeater-minimize"></i>
                            </a>
                        </div>

                        <div class="repeater-row-content">
                            <p>
                                <label for="<?php echo $this->get_field_id( 'sliders[' . $key . '][slider_title]' ); ?>"><?php _e( 'Title:', 'castpro5' ); ?></label>
                                <input type="text" id="<?php echo $this->get_field_id( 'sliders[' . $key . '][slider_title]' ); ?>" class="widefat slider-title" name="<?php echo $this->get_field_name( 'sliders[' . $key . '][slider_title]' ); ?>" value="<?php echo $sliderimage['slider_title']; ?>">
                            </p>

                            <p>
                                <label for="<?php echo $this->get_field_id( 'sliders[' . $key . '][slider_order]' ); ?>"><?php _e( 'Order:', 'castpro5' ); ?></label>
                                <input type="number" id="<?php echo $this->get_field_id( 'sliders[' . $key . '][slider_order]' ); ?>" class="widefat" name="<?php echo $this->get_field_name( 'sliders[' . $key . '][slider_order]' ); ?>" value="<?php echo esc_attr( $slider_order ); ?>">
                            </p>

                            <div class="media-image">
                                <div class="slider-image-title"><?php _e( 'Slider images:', 'castpro5' ); ?></div>
                <?php
                if ( $sliderimage['slider_image'] ) {

                    $slider_image = $sliderimage['slider_image'];
                } else {

                    $slider_image = 'data:image/gif;base64,R0lGODlhAQABAIAAAAAAAAAAACH5BAEAAAAALAAAAAABAAEAAAICRAEAOw%3D%3D';
                }
                ?>
                                <div class="slider-image-thumb <?php if ( $sliderimage['slider_image'] ) { ?>uploaded<?php } ?>">
                                    <a href="#" class="slider-image-add">
                                        <img src="<?php echo $sliderimage['slider_image']; ?>" class="slider-image">
                                        <input type="hidden" id="<?php echo $this->get_field_id( 'sliders[' . $key . '][slider_image]' ); ?>" name="<?php echo $this->get_field_name( 'sliders[' . $key . '][slider_image]' ); ?>" class="widefat upload-image-url" value="<?php echo $sliderimage['slider_image']; ?>" >
                                    </a>
                                </div>

                                <div class="uploaded-actions">
                                    <button class="slider-image-remove button"><?php _e( 'Delete the image', 'castpro5' ); ?></button>
                                    <button class="slider-image-add button"><?php _e( 'Change the image', 'castpro5' ); ?></button>
                                </div>

                                <div class="attachment-media-view">
                                    <div class="placeholder"><?php _e( 'Image has not been selected', 'castpro5' ); ?></div>
                                    <div class="actions">
                                        <button type="button" class="button slider-image-add"><?php _e( 'Add Slider image', 'castpro5' ); ?></button>
                                    </div>
                                </div>
                            </div>

                            <p>
                                <label for="<?php echo $this->get_field_id( 'sliders[' . $key . '][slider_url]' ); ?>"><?php _e( 'URL:', 'castpro5' ); ?></label>
                                <input type="text" id="<?php echo $this->get_field_id( 'sliders[' . $key . '][slider_url]' ); ?>" class="widefat" name="<?php echo $this->get_field_name( 'sliders[' . $key . '][slider_url]' ); ?>" value="<?php echo $sliderimage['slider_url']; ?>">
                            </p>

                            <p>
                                <input id="<?php echo $this->get_field_id( 'sliders[' . $key . '][slider_blank]' ); ?>" class="checkbox" name="<?php echo $this->get_field_name( 'sliders[' . $key . '][slider_blank]' ); ?>" <?php checked( 'on', $sliderimage['slider_blank'] ); ?> type="checkbox">
                                <label for="<?php echo $this->get_field_id( 'sliders[' . $key . '][slider_blank]' ); ?>"><?php _e( 'Displayed in another window', 'castpro5' ); ?></label>
                            </p>

                            <div class="remove-actions">
                                <button class="button-link repeater-row-remove" type="button"><?php _e( 'Remove', 'castpro5' ); ?></button>
                            </div>
                        </div>

                    </li>
            <?php }
            ?>
            </ul>
            <p><button class="button-secondary repeater-add"><?php _e( 'Add new row', 'castpro5' ); ?></button></p>
            <?php
        }

        function admin_scripts() {


            wp_enqueue_style( 'widget-slider-uploader', plugins_url( 'css/widget-slider-uploader.css', CP5PE_MAIN ), array(), '1.0', 'all' );

            wp_enqueue_script( 'jquery-ui-core' );
            wp_enqueue_script( 'jquery-ui-mouse' );
            wp_enqueue_script( 'jquery-ui-widget' );
            wp_enqueue_script( 'jquery-ui-selectable' );
            wp_enqueue_script( 'jquery-ui-accordion' );
            wp_enqueue_script( 'jquery-ui-sortable' );

            wp_enqueue_media();
            wp_enqueue_script( 'widget-slider-uploader', plugins_url( 'js/widget-slider-uploader.js', CP5PE_MAIN ), array( 'jquery', 'jquery-ui-sortable', 'customize-controls' ) );
        }

        function widget_slider_enqueue_scripts( $instance ) {

            wp_enqueue_style( 'swiper', get_template_directory_uri() . '/lib/swiper/css/swiper.min.css', array(), '3.4.0', 'all' );
            wp_enqueue_script( 'swiper', get_template_directory_uri() . '/lib/swiper/js/swiper.min.js', array( 'jquery' ), '3.4.0', true );

            $slider_options = get_option( $this->option_name );

            unset( $slider_options['_multiwidget'] );

            foreach ( ( array ) $slider_options as $slider_key => $slider_op ) {

                if ( !is_active_widget( false, $this->id_base . '-' . $slider_key, $this->id_base, true ) ) {

                    continue;
                }

                $slider_config = array();

                /*
                  if ( isset( $slider_op['width'] ) ) {
                  // $slider_config['width'] =  sprintf("'%s'",$slider_op['width']);
                  }

                  if ( isset( $slider_op['height'] ) ) {
                  $slider_config['height'] = sprintf("'%s'",$slider_op['height']);
                  }
                 */
                //スピード
                if ( isset( $slider_op['slidespeed'] ) ) {
                    $slider_config['speed'] = ( int ) $slider_op['slidespeed'];
                }

                //ループ
                if ( isset( $slider_op['loop'] ) ) {
                    $slider_config['loop'] = 'true';
                }

                //エフェクト
                if ( isset( $slider_op['effect'] ) ) {
                    $slider_config['effect'] = $slider_op['effect'];
                }

                //スライド数
                if ( isset( $slider_op['slidenumber'] ) && $slider_op['slidenumber'] ) {
                    $slider_config['slidesPerView'] = $slider_op['slidenumber'];
                }

                //高さを自動調整

                if ( isset( $slider_op['autoheight'] ) && $slider_op['autoheight'] === 'on' ) {
                    $slider_config['autoHeight'] = 'true';
                }

                //オートプレイ
                if ( isset( $slider_op['autoplay'] ) && $slider_op['autoplay'] === 'on' ) {
                    $slider_config['autoplay'] = ( int ) $slider_op['autoplayspeed'];
                }


                //ページネーション
                if ( isset( $slider_op['pagination'] ) && $slider_op['pagination'] === 'on' ) {
                    $slider_config['pagination'] = '.swiper-pagination';
                    $slider_config['paginationClickable'] = 'true';
                }

                //ナビゲーション
                if ( isset( $slider_op['navigation'] ) && $slider_op['navigation'] == true ) {
                    $slider_config['nextButton'] = '.swiper-button-next';
                    $slider_config['prevButton'] = '.swiper-button-prev';
                }

                wp_add_inline_script( 'swiper', "
             var swiper" . $this->id_base . $slider_key . " = new Swiper('#swiper-container-" . $this->id_base . "-" . $slider_key . "'," . json_encode( $slider_config ) . ");
     " );
            }
        }

    }

//ウィジェット生成用アクションフィルタ
    add_action( 'widgets_init', create_function( '', 'return register_widget("CP5_Slider_Widget");' ) );
    