<?php

/**
 * Description of widget_castlist
 *
 * @author Rika.K
 */
class CP5_Widget_TodaySchedule extends CP5_Widget_Schedule {

    function __construct() {
        $this->widget_name = '本日の出勤一覧';
        $this->widget_default_label = '本日の出勤一覧';

        CP5_Widget::__construct();
    }

    /**
     * 本日の出勤予定
     * @param type $args
     * @param type $instance
     */
    public function widget( $args, $instance ) {
        $instance = $this->instance_update_default( $instance );

        //現在時刻
        $this->startTime = CP5::get_switchTime( 'U' ) - CP5::get_gmt_offset();
        $this->endTime = $this->startTime + DAY_IN_SECONDS;

        $dateFormat = get_option( 'date_format' );
        $titleDt = date_i18n( $dateFormat, CP5::add_gmt_offset( $this->startTime ) );
        $instance['title'] = $titleDt . $instance['title'];

        echo $args['before_widget'];
        //echo $this->view_schedule_widget_body( $args, $instance );
        echo $args['after_widget'];
    }

}

/*
 * Wordpressへ登録 
 */

add_action( 'widgets_init', function() {
    return register_widget( 'CP5_Widget_TodaySchedule' );
} );
